//
//  PlayerViewController+otherDelegate.m
//  隐私保护
//
//  Created by xd h on 2023/10/13.
//

#import "PlayerViewController+otherDelegate.h"
#import "RCCommandHelp.h"

@implementation PlayerViewController (otherDelegate)

#pragma mark   ComontAlretViewControllerDelegate
- (void)CommonAlertokBtnClickPressed{
    //HLog("11111");
    
    self.isLoginAgainType = YES;
    
    [[NSNotificationCenter defaultCenter] postNotificationName:lockBypwdNotification object:nil];
}
- (void)CommonAlertCancelBtnClickPressed{
    HLog("强制退出app");
    
    exit(0);/*强制退出app*/
}



#pragma mark 监听文件开始的的通知
- (void)beginGotoUploadFileFun:(NSNotification *)notification
{
    self.isSuspendUploadType = NO;
    
    uploadFileDataModel *uploadFileDataMod = [notification object];
    //HLog(@"%@",uploadFileDataMod);
    self.curUploadFileDataMod = uploadFileDataMod;
    
    if(![uploadFileDataMod isKindOfClass:[uploadFileDataMod class]]){
        HLog(@"上传的文件类型不对");
        return;
    }
    
    [self ApplyUploadFileFun];
}

- (void)applyUploadFileServiceResponseFun:(NSDictionary *)dataDict
{
    if([dataDict isKindOfClass:[NSDictionary class]]){
        if ([[dataDict allKeys] containsObject:@"data"]) {
            NSDictionary *data = dataDict[@"data"];

            if ([[data allKeys] containsObject:@"status"]) {
                NSString  *status = [data objectForKey:@"status"];
                if(![status isKindOfClass:[NSString class]]){
                    status = [[NSString  alloc] initWithFormat:@"%@",status];
                }
                
                if ([status isEqualToString:@"1"]) {
                    [self tryAgainApplyUploadFun];
                    
                }else if ([status isEqualToString:@"0"]){
                    if ([[data allKeys] containsObject:@"taskUid"]) {
                        NSString *taskUid = data[@"taskUid"];
                        if(![status isKindOfClass:[NSString class]]){
                            taskUid = [[NSString  alloc] initWithFormat:@"%@",taskUid];
                        }
                        
                        if(taskUid &&  [taskUid isEqualToString:self.taskUid]){
                            
                            NSNumber * fileLengthNum = @0;
                            if ([[data allKeys] containsObject:@"fileLength"])
                            {
                                fileLengthNum = data[@"fileLength"];
                            }
                            
                            [[uploadFileManager shareInstance] changeUploadFileState:uploadStateUploading withDidUploadBytes:[fileLengthNum integerValue] complete:^(BOOL isSuccess) {
                                
                            }];
                            
                            if([fileLengthNum integerValue] == [self.AllFileData length]){
                                self.taskUid = nil;
                                
                                NSMutableArray *delArr = [NSMutableArray new];
                                [delArr addObject:self.curUploadFileDataMod];
                                [[uploadFileManager shareInstance] deleteUploadFileRecordBy:delArr complete:^(BOOL isSuccess) {
                                    if (isSuccess) {
                                        [[NSNotificationCenter defaultCenter] postNotificationName:uploadFileDeteleNotification object:self.curUploadFileDataMod];
                                    }
                                }];
                                
                                mainBlock(^{
                                    [[iToast makeText:NSLocalizedString(@"File_upload_file_already_exists",nil)] show];
                                });
                                HLog(@"hxd already 上传任务异常终止")
                                return;
                            }
                            
                            self.cutFileDataArr = [self fileCutPartsBy:self.AllFileData withDidUpLoadSize:[fileLengthNum integerValue]];
                            
                            if(!self.cutFileDataArr){
                                [[uploadFileManager shareInstance] changeUploadFileState:uploadStateFail withDidUploadBytes:[fileLengthNum integerValue] complete:^(BOOL isSuccess) {

                                }];
                                
                                self.taskUid = nil;
                                
                                mainBlock(^{
                                    [[iToast makeText:NSLocalizedString(@"File_upload_fail",nil)] show];
                                });
                                HLog(@"hxd fail 上传任务异常终止")
                                return;
                            }
                            
                            
                            
                            //答复的taskUid 跟申请的一致 开发发送内容
                            [self upLoadFileFun];
                        }
                    }
                   
                }
            }
        }
        else{
            //异常
            [self tryAgainApplyUploadFun];
        }
    }
    else{
        //异常
        [self tryAgainApplyUploadFun];
    }
}

- (void)upLoadFileFunServiceResponseFun:(NSDictionary *)dataDict
{
    //{"type":"uploadFileRandomRet","data":{"progress":"9\/10","filePath":"/sdcard/Download/IMG_0036.JPG","status":"0","msg":"success"}}
    
    if([dataDict isKindOfClass:[NSDictionary class]]){
        if ([[dataDict allKeys] containsObject:@"data"]) {
            NSDictionary *data = dataDict[@"data"];

            if ([[data allKeys] containsObject:@"status"]) {
                NSString  *status = [data objectForKey:@"status"];
                if(![status isKindOfClass:[NSString class]]){
                    status = [[NSString  alloc] initWithFormat:@"%@",status];
                }
                
                if ([status isEqualToString:@"1"]) {
                    [self tryAgainApplyUploadFun];
                }else if ([status isEqualToString:@"0"]){
                    [self handleUploadingFun];
                }
            }
        }
        else{
            //异常
            [self tryAgainApplyUploadFun];
        }
    }
    else{
        //异常
        [self tryAgainApplyUploadFun];
    }
    
}

#pragma mark 申请上传文件
- (void)ApplyUploadFileFun
{
    if(!self.taskUid){
        self.taskUid = [iTools getTaskUidStr];
        self.fileName = self.curUploadFileDataMod.filename;
        if(self.curUploadFileDataMod.curUploadFileType == uploadFileTypeVideo){
            self.AllFileData = self.curUploadFileDataMod.videoData;
        }
        else{
            self.AllFileData = self.curUploadFileDataMod.imageData;
        }
        
        self.indexOfUploadFlie = 0;
        
        //HLog(@"%@  %@",self.taskUid,self.fileName);
        //self.cutFileDataArr = [self fileCutPartsBy:self.AllFileData];
    }
    
    NSString * commandStr = [RCCommandHelp applyForUploadFileBy:self.taskUid  filePath:self.fileName];
    [self.commandChannelManager rc_sendData:commandStr];
}

#pragma mark 遇到异常时 重新上传
- (void)tryAgainApplyUploadFun
{
    self.taskUid = nil;
    [self ApplyUploadFileFun];
}

#pragma mark 处理上传过程
- (void)handleUploadingFun
{
    if(self.isSuspendUploadType){
        //暂停
        self.taskUid = nil;
        NSInteger didUploadSize = (self.indexOfUploadFlie+1) * (self.cutFileEachPieceSzie);
        [[uploadFileManager shareInstance] changeUploadFileState:uploadStateSuspend withDidUploadBytes:didUploadSize complete:^(BOOL isSuccess) {

        }];
        
        return;
    }
    
    if(self.indexOfUploadFlie < self.cutFileDataArr.count -1) {
        
        NSInteger didUploadSize = (self.indexOfUploadFlie+1) * (self.cutFileEachPieceSzie);
        
        [[uploadFileManager shareInstance] changeUploadFileState:uploadStateUploading withDidUploadBytes:didUploadSize complete:^(BOOL isSuccess) {

        }];
        
        self.indexOfUploadFlie ++;
        [self upLoadFileFun];
    }
    else{
        HLog(@"上传完成");
        
        //上传数据清空
        self.taskUid = nil;
        self.fileName = nil;
        self.AllFileData = nil;
        self.indexOfUploadFlie = 0;
        self.cutFileDataArr = nil;
        
        [[uploadFileManager shareInstance] uploadFileDoneFun];
    }
}


- (Byte)getBCC:(NSData *)data {
    Byte bcc = 0;
    unsigned char *bytes = (unsigned char *)[data bytes];
    for (int i = 0; i < [data length]; i++) {
        bcc = (Byte)(bcc ^ bytes[i]);
    }
    return bcc;
}


#pragma mark 文件切片
-(NSMutableArray *)fileCutPartsBy:(NSData*)curData withDidUpLoadSize:(NSInteger)didLoadSize{
 
    NSData * data = curData;
    
    NSUInteger allLength = data.length;
    
    NSUInteger subs = 100*1024;//4096;//要切片的大小，我这里设置的是4096字节
    //NSUInteger subs = 8*1024;//4096;//要切片的大小，我这里设置的是4096字节
    self.cutFileEachPieceSzie = subs;
    
    NSInteger index = 0;//起始位置
    
    if(didLoadSize != 0){
        if (didLoadSize % subs != 0){
            //出错了
            return nil;
        }
        else{
//            index = didLoadSize/subs;
//            allLength = allLength - didLoadSize;
            
            self.indexOfUploadFlie = didLoadSize/subs;
        }
    }

    NSMutableArray *dataArray =[NSMutableArray new];
    
    do {

        if (allLength>subs) {
            
            NSRange range =NSMakeRange(index*subs, subs);
            
            index++;
            
            //NSLog(@"%@",NSStringFromRange(range));
            
            [dataArray addObject:[data subdataWithRange:range]];
            
            allLength = allLength - subs;

        }else{
            
            NSRange range = NSMakeRange(index*subs, allLength);
            
            //NSLog(@"%@",NSStringFromRange(range));
            
            [dataArray addObject:[data subdataWithRange:range]];

            allLength = 0;
        }

        
    } while (allLength>0);
    
    HLog(@"dataArray leng:%ld",dataArray.count);//最后得到切片的结果，数组里面是NSData对象

    return dataArray;
}

// int转NSData
- (NSData *)int2Data:(int)i{
    Byte b0 = i & 0xff;
    Byte b1 = i >> 8 & 0xff;
    Byte b2 = i >> 16 & 0xff;
    Byte b3 = i >> 24 & 0xff;
    // 有大小端模式问题？
    //Byte result[] = {b0, b1, b2, b3};
    Byte result[] = {b3, b2, b1, b0};
    return [NSData dataWithBytes:result length:sizeof(result)];
}

// short转NSData
- (NSData *)short2Data:(short)i{
    Byte b0 = i & 0xff;
    Byte b1 = i >> 8 & 0xff;
    // 有大小端模式问题？
    //Byte result[] = {b0, b1, b2, b3};
    Byte result[] = { b1, b0};
    return [NSData dataWithBytes:result length:sizeof(result)];
}

#pragma mark 可以发送文件了
/*
文件数据字节流byte[]
  格式1:下载日志文件压缩包
       |head|msgType|taskId|    datalen            | curNum | totalNum|   data   |bcc校验|end|
  长度：  1      1      6 （curNum+totalNum+data）        4         4      datalen- 8   1     1
       0x68  0x0e                                                        0x16
    bcc校验从第1位 也就是从msgType起 到 校验位前（不包含校验位）数据作bcc校验
 */
- (void)upLoadFileFun
{
    //HLog(@"上传文件%ld/%ld",self.indexOfUploadFlie +1,self.cutFileDataArr.count);
    //data
    NSData *curData = self.cutFileDataArr[self.indexOfUploadFlie];
    //HLog(@"headData:%@",curData);
    
    //head
    unsigned char headNum = 104;
    NSData *headData = [NSMutableData dataWithBytes:&headNum length:sizeof(headNum)];
    //HLog(@"headData:%@",headData);
    
    //msgType
    //unsigned char msgType = 12;
    unsigned char msgType = 15;
    NSData *msgTypeData = [NSMutableData dataWithBytes:&msgType length:sizeof(msgType)];
    //HLog(@"msgTypeData:%@",msgTypeData);
    
    //taskId
    NSData *taskIdData = [self.taskUid dataUsingEncoding:NSUTF8StringEncoding];
    //HLog(@"taskIdData:%@",taskIdData);
    
    //datalen
    int datalenNum = int([curData length] +(4+4));
    //NSData *datalenData = [NSData dataWithBytes:&datalenNum length:sizeof(datalenNum)];
    NSData *datalenData = [self int2Data:datalenNum];
    //HLog(@"datalenData %@",datalenData);
    
    
    //curNum
    int curNum = (int)self.indexOfUploadFlie;
    //NSData *curNumData = [NSData dataWithBytes:&curNum length:sizeof(curNum)];
    NSData * curNumData = [self int2Data:curNum];
    //HLog(@"curNumData:%@",curNumData);
    
    //totalNum
    int totalNum = (int)self.cutFileDataArr.count;
    //NSData *totalNumData = [NSData dataWithBytes:&totalNum length:sizeof(totalNum)];
    NSData * totalNumData = [self int2Data:totalNum];
    //HLog(@"totalNumData:%@",totalNumData);
    

    NSMutableData *checkBCCData = [NSMutableData new];
    [checkBCCData appendData:msgTypeData];
    [checkBCCData appendData:taskIdData];
    [checkBCCData appendData:datalenData];
    [checkBCCData appendData:curNumData];
    [checkBCCData appendData:totalNumData];
    [checkBCCData appendData:curData];
    
    int length = [curData length];
    //HLog(@"curData length %d",length);
    
    Byte bccCheck = [self getBCC:checkBCCData];
    //HLog(@"bcc 000 %d",bccCheck);
    
    //bcc校验
    char bccNum = (char)bccCheck;
    NSData *bccData = [NSMutableData dataWithBytes:&bccNum length:sizeof(bccNum)];
    //HLog(@"%@",bccData);
    
    //end
    unsigned char endNum = 22;
    NSData *endData = [NSMutableData dataWithBytes:&endNum length:sizeof(endNum)];
    //HLog(@"%@",endData);
    
    NSMutableData *sendData = [NSMutableData new];
    [sendData appendData:headData];
    [sendData appendData:checkBCCData];
    [sendData appendData:bccData];
    [sendData appendData:endData];
    
    //HLog(@"sendData length %ld",[sendData length]);
    [self.commandChannelManager rc_sendData:sendData];
    //HLog(@"文件上传sendData %@",sendData);
}

- (void)suspendUploadFileFun:(NSNotification *)notification
{
    self.isSuspendUploadType = YES;
}

@end
